/*******************
 VARIABLES
*******************/
var lastModified = "2021-05-31";
var lastUploaded = "2021-05-31";

var templateVersion = "1.0.0";
var dimensions;
var scrollPos = {
	x: 0,
	y: 0
};
var adId, rnd, uid;
var expandButton;
var wasPanelLoadReported = false;

/*******************
 INITIALIZATION
*******************/
function checkIfAdKitReady(event) {
	try {
	}
	catch(e) {}

	adkit.onReady(initializeCreative);
}

function initializeCreative(event) {
	// so messaging can work in safe frames we need to bind the events that are present in the event manager.
	try {
		EBG.pm.bind("sendCreativeId", function () {
			eventManager.apply(this, arguments);
		}, this);
		EBG.pm.bind("eventCallback", function () {
			eventManager.apply(this, arguments);
		}, this);
	}
	catch(e) {}
	initializeGlobalVariables();
	displayDimensions();
	addEventListeners();
	setTimeout(checkIfVisibleOnLoad, 1000);

}

function initializeGlobalVariables() {
	adId = EB._adConfig.adId;
	rnd = EB._adConfig.rnd;
	uid = EB._adConfig.uid;
	expandButton = document.getElementById("expand_button");
	userActionButton = document.getElementById("user_action");
	clickthroughButton = document.getElementById("clickthrough");
    overlay_hotspot=document.getElementById("overlay_hotspot");
}

function addEventListeners() {
	expandButton.addEventListener("click", expand);
    userActionButton.addEventListener("click", userAction);
	clickthroughButton.addEventListener("click", clickthrough);
    overlay_hotspot.addEventListener("click", clickthroughOverLay);
    startDCO();
}
function startDCO() {
    if (window.location.protocol == "file:" || window.location.protocol == "http:"){
		$("#logo").attr('src', EB.getAssetUrl("",adkit.getSVData("logo")));
		
	}else{
		$("#logo").attr('src', adkit.getSVData("logo"));
		
	}
}

function checkIfVisibleOnLoad() {
	if(isFirstExpansion()) {
		if(isAdVisible()) {
			if(!wasPanelLoadReported) {
				wasPanelLoadReported = true;
				EB.automaticEventCounter("Leave_Behind_Load");
			}
		}
		else {
			window.addEventListener("resize", checkIfVisible);
		}
	}
}

function checkIfVisible(event) {
	if(isAdVisible()) {
		EB.automaticEventCounter("Ad_Resize_AdShown");
		window.removeEventListener("resize", checkIfVisible);
	}
}

function isAdVisible() {
	return window.innerWidth > 0 && window.innerHeight > 0;
}

function isFirstExpansion() {
	return EB._adConfig && EB._adConfig.customJSVars && EB._adConfig.customJSVars.mdIsFirstExpand;
}
/*******************
 EVENT HANDLERS
*******************/
function expand(event) {

	EB.expand();
}

function userAction(event) {
	EB.userActionCounter("UserAction");
    
    
}
function clickthrough(event) {
	EB.clickthrough();
   
}
function clickthroughOverLay(event) {
	EB.clickthrough("Click_Main");
   
}

function onPageScroll(event) {
	scrollPos.x = event.scrollXPercent;
	scrollPos.y = event.scrollYPercent;
	displayDimensions();
}
/*******************
 UTILITIES
*******************/
function displayDimensions() {
	if(dimensions) {
		var iw = window.innerWidth,
			ih = window.innerHeight,
			sx = scrollPos.x,
			sy = scrollPos.y;
		var str = "<br>Viewport: " + iw + "x" + ih + " | <span style='display:block'>Scroll (X: " + sx + "%; Y: " + sy + "%)</span>";
		dimensions.innerHTML = str;
	}
}
/*********************************
HTML5 Event System - Do Not Modify
*********************************/
var listenerQueue;
var creativeIFrameId;

function sendMessage(type, data) {
	if(!data.type) data.type = type;
	EB._sendMessage(type, data);
}

function addCustomScriptEventListener(eventName, callback, interAd) {
	listenerQueue = listenerQueue || {};
	var data = {
		uid: uid,
		listenerId: Math.ceil(Math.random() * 1000000000),
		eventName: eventName,
		interAd: !!(interAd),
		creativeIFrameId: creativeIFrameId
	};
	sendMessage("addCustomScriptEventListener", data);
	data.callback = callback;
	listenerQueue[data.listenerId] = data;
	return data.listenerId;
}

function dispatchCustomScriptEvent(eventName, params) {
	params = params || {};
	params.uid = uid;
	params.eventName = eventName;
	params.creativeIFrameId = creativeIFrameId;
	sendMessage("dispatchCustomScriptEvent", params);
}

function removeCustomScriptEventListener(listenerId) {
	var params = {
		uid: uid,
		listenerId: listenerId,
		creativeIFrameId: creativeIFrameId
	};

	sendMessage("removeCustomScriptEventListener", params);

	if(listenerQueue[listenerId])
		delete listenerQueue[listenerId];
}

function eventManager(event) {
	var msg;
	if(typeof event == "object" && event.data) {
		msg = JSON.parse(event.data);
	}
	else {
		// this is safe frame.
		msg = {
			type: event.type,
			data: event
		};
	}
	if(msg.type && msg.data && (!uid || (msg.data.uid && msg.data.uid == uid))) {
		switch(msg.type) {
		case "sendCreativeId":
			creativeIFrameId = msg.data.creativeIFrameId;
			addCustomScriptEventListener('pageScroll', onPageScroll);
			sendMessage("dispatchScrollPos", {
				uid: uid
			});
			if(creativeContainerReady)
				creativeContainerReady();
			break;
		case "eventCallback": // Handle Callback
			var list = msg.data.listenerIds;
			var length = list.length;
			for(var i = 0; i < length; i++) {
				try {
					var t = listenerQueue[list[i]];
					if(!t) continue;
					t.callback(msg.data);
				}
				catch(e) {}
			}
			break;
		}
	}
}

window.addEventListener("message", function () {
	try {
		eventManager.apply(this, arguments);
	}
	catch(e) {}
}, false);
/*************************************
End HTML5 Event System - Do Not Modify
*************************************/

window.addEventListener("load", checkIfAdKitReady);